import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/objectWithoutPropertiesLoose";
var _excluded = ["html", "css", "js", "title", "head", "onLoad"];
import React, { useMemo, useRef, useState } from 'react';
import ReactDOM from 'react-dom';
import { jsx as _jsx } from "react/jsx-runtime";
export default /*#__PURE__*/React.forwardRef((props, ref) => {
  var {
    html = '',
    css,
    js,
    title = 'Demo Title',
    head,
    onLoad: _onLoad
  } = props,
      other = _objectWithoutPropertiesLoose(props, _excluded);

  var [isLoaded, setIsLoaded] = useState(false);
  var frameRef = useRef(null);
  var srcDoc = useMemo(() => {
    setIsLoaded(false);
    var jsString = js ? "<script type=\"text/javascript\">" + js + "</script>" : '';
    var cssString = css ? "<style>" + css + "</style>" : '';
    return "<!DOCTYPE html><html><head>" + cssString + "</head><body>" + html + "</body>" + jsString + "</html>";
  }, [css, html, js]);

  function renderFrameContents() {
    if (!frameRef.current || !frameRef.current.contentDocument || !frameRef.current.contentWindow) return null;
    return [/*#__PURE__*/ReactDOM.createPortal(head, frameRef.current.contentDocument.head)];
  }

  return /*#__PURE__*/_jsx("iframe", _extends({
    title: title,
    width: "100%",
    height: "100%",
    style: {
      border: 0
    }
  }, other, {
    onLoad: evn => {
      setIsLoaded(true);
      _onLoad && _onLoad(evn);
    },
    ref: frameRef,
    srcDoc: srcDoc,
    children: isLoaded && renderFrameContents()
  }));
});
//# sourceMappingURL=index.js.map